uniform sampler2D id_tex;
uniform sampler2D ao_tex;
uniform float nr_lights;

varying vec3 startIn;
varying vec3 dirIn;
varying float radiusIn;

varying vec2 ao_pos;
varying vec3 center;

varying vec3 normal_1;
varying vec3 normal_2;

void main()
{
	float u = gl_TexCoord[0].s;
	float v = gl_TexCoord[0].t;
	vec2 circlePos;
	vec3 cylPos;
	vec4 lightPos;
	vec4 curr_col;

	float sn;

	if(u >= 0.0) {
		circlePos = vec2(1.0 - abs(2.0*u - 1.0), 2.0*u - 1.0);
	} else {
		circlePos = vec2(abs(2.0*u - 1.0) - 1.0, 2.0*u + 1.0);
	}
	// From here needs editing
	circlePos = normalize(circlePos);
	cylPos = (circlePos.x * normal_1 + circlePos.y * normal_2) * radiusIn + v * dirIn + center;
	lightPos = gl_TextureMatrix[7] * vec4(cylPos, 1.0);
	lightPos = lightPos / lightPos.w;

	curr_col = texture2D(ao_tex, ao_pos * 0.5 + vec2(0.5));
	//curr_col = vec4(0.0, 0.0, 0.0, 1.0);

	if( texture2D(id_tex,lightPos.st).z < lightPos.z) {
	  // shadow
	  gl_FragColor = curr_col;
	} else {
	  gl_FragColor = curr_col + vec4(vec3(2.0 / nr_lights), 1.0);
	}
	//gl_FragColor = vec4(texture2D(id_tex,lightPos.st).z);
	//gl_FragColor = vec4(texture2D(id_tex,gl_TexCoord[0].st).z);
	//gl_FragColor = vec4(v*0.5 + 0.5);

	// Use this to verify the id_buffer:
	//gl_FragColor = texture2D(id_tex, gl_TexCoord[0].st * 0.5 + vec2(0.5));
	//gl_FragColor = vec4(cylPos.xyz * 0.3 + vec3(0.5), 1.0);

	gl_FragColor.a = 1.0;
}

#if 0
uniform int first_run;

uniform sampler2D id_tex;
uniform sampler2D ao_tex;
varying vec2 ao_pos;

void main(void)
{
	float diff;
	vec4 id_vec;
	vec4 addition;
	vec4 current;
	
	id_vec = texture2D(id_tex, gl_TexCoord[0].st);
	diff = length(gl_Color - id_vec);
	addition = vec4(vec3(diff < 0.1? 1.0/14.0 : 0.0), 1.0);
	current = ((first_run == 1) ? vec4(0.0) : texture2D(ao_tex, ao_pos));
  gl_FragColor = addition + current;
}
#endif