attribute float rank;
varying float atom_rank;
attribute float radius;
varying float atom_radius;
attribute float id;
varying float atom_id;
attribute float type;
varying float atom_type;

varying vec3 pastel_lightIn;
varying vec3 pastel_darkIn;

/* Structural abstraction lookup variables */
attribute float abstraction_lookup_pos;
uniform sampler1D abstraction_lookup;
varying float structural_abs;
varying float illustrativenessIn;

attribute vec2 ao_tex_pos;
uniform float ao_block_width;

// Color map
uniform sampler2D colormap;
attribute float atom_coord;

void main() {
	vec4 color;

	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_TexCoord[0].pq = ao_tex_pos;
	gl_Position = gl_Vertex;
	atom_rank = rank;
	atom_radius = radius;
	atom_id = id;
	atom_type = type;

	/* Get all colors from the color map */
	color = texture2D(colormap, vec2(0.0, atom_coord));
	gl_FrontColor = color;
	gl_BackColor = color;
	pastel_lightIn = texture2D(colormap, vec2(0.5, atom_coord)).rgb;
	pastel_darkIn = texture2D(colormap, vec2(1.0, atom_coord)).rgb;
	
	structural_abs = texture1D(abstraction_lookup, abstraction_lookup_pos).r;
	illustrativenessIn = texture1D(abstraction_lookup, abstraction_lookup_pos).b;
}
